version: '3.7'

services:
  compile_protobuf_files:
    build:
      context: .
      target: compile_protobuf_files
    volumes:
      - ".:/data"
  proto_lint:
    build:
      context: .
      target: proto_lint
    volumes:
      - ".:/data"
  go_lint:
    build:
      context: .
      target: go_lint
    volumes:
      - ".:/data"
  generate_mocks:
    build:
      context: .
      target: generate_mocks
    volumes:
      - ".:/data"
  mongodb:
    image: mongo
    container_name: mongodb
    ports:
      - "27017:27017"
    environment:
      MONGO_INITDB_ROOT_USERNAME: root_dev
      MONGO_INITDB_ROOT_PASSWORD: root_dev_password
    volumes:
      - ".mongodata:/data/db"
    networks:
      - our_network
  test-unit:
    build:
      context: .
      target: test-unit
    volumes:
      - ".:/data"
  test-integration:
    environment:
      - CI=1 # to use values_docker.yaml in integration tests
    build:
      context: .
      target: test-integration
    volumes:
      - ".:/data"
    depends_on:
      - mongodb
    networks:
      - our_network
  test-coverage:
    environment:
      - CI=1 # to use values_docker.yaml in integration tests
    build:
      context: .
      target: test-coverage
    volumes:
      - ".:/data"
    depends_on:
      - mongodb
    networks:
      - our_network
  go-build:
    build:
      context: .
      target: go-build
    volumes:
      - ".:/data"
  ###################### kafka ######################
  zookeeper:
    image: wurstmeister/zookeeper
    ports:
      - "2181:2181"
    networks:
      - our_network
  kafka:
    image: wurstmeister/kafka
    ports:
      - "9092:9092"
    environment:
      DOCKER_API_VERSION: 1.22
      KAFKA_ADVERTISED_HOST_NAME: 127.0.0.1
      KAFKA_ZOOKEEPER_CONNECT: zookeeper:2181
      KAFKA_AUTO_CREATE_TOPICS_ENABLE: 'true'
      # 1 partition; 1 replicas
      KAFKA_CREATE_TOPICS: "users-api:1:1"
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
    depends_on:
      - zookeeper
    networks:
      - our_network
  ###################### end of: kafka ######################
  run-binary:
    build:
      context: .
      target: run-binary
    ports:
      - "80:80" # http
      - "90:90" # grpc
    volumes:
      - ".:/data"
    depends_on:
      - kafka
      - mongodb
    networks:
      - our_network
networks:
  our_network:
